RDKit::CartesianProduct Struct Reference

iterate through all possible permutations of the rgroups More...

`#include <RGroupScore.h>`

## Public Member Functions

| CartesianProduct (const std::vector< size_t > &inputSizes)
bool | next ()
size_t | value (const std::vector< size_t > &p) const
size_t | value ()
bool | increment (size_t rowToIncrement)

## Public Attributes

std::vector< size_t > | permutation
std::vector< size_t > | sizes
std::deque< size_t > | bases
size_t | maxPermutations
size_t | permutationCount

## Detailed Description

iterate through all possible permutations of the rgroups

Definition at line 20 of file RGroupScore.h.

## Constructor & Destructor Documentation

## CartesianProduct()

RDKit::CartesianProduct::CartesianProduct | ( | const std::vector< size_t > & | inputSizes | ) |

inline

Definition at line 26 of file RGroupScore.h.

References bases, maxPermutations, and sizes.

## Member Function Documentation

## increment()

bool RDKit::CartesianProduct::increment | ( | size_t | rowToIncrement | ) |

inline

Definition at line 56 of file RGroupScore.h.

References maxPermutations, permutation, permutationCount, and sizes.

Referenced by next().

## next()

bool RDKit::CartesianProduct::next | ( |  | ) |

inline

Definition at line 37 of file RGroupScore.h.

References increment(), and permutationCount.

## value() [1/2]

size_t RDKit::CartesianProduct::value | ( |  | ) |

inline

Definition at line 54 of file RGroupScore.h.

References permutation, and value().

Referenced by value().

## value() [2/2]

size_t RDKit::CartesianProduct::value | ( | const std::vector< size_t > & | p | ) | const

inline

Definition at line 46 of file RGroupScore.h.

References bases.

## Member Data Documentation

## bases

std::deque<size_t> RDKit::CartesianProduct::bases

Definition at line 23 of file RGroupScore.h.

Referenced by CartesianProduct(), and value().

## maxPermutations

size_t RDKit::CartesianProduct::maxPermutations

Definition at line 24 of file RGroupScore.h.

Referenced by CartesianProduct(), and increment().

## permutation

std::vector<size_t> RDKit::CartesianProduct::permutation

Definition at line 21 of file RGroupScore.h.

Referenced by increment(), and value().

## permutationCount

size_t RDKit::CartesianProduct::permutationCount

Definition at line 25 of file RGroupScore.h.

Referenced by increment(), and next().

## sizes

std::vector<size_t> RDKit::CartesianProduct::sizes

Definition at line 22 of file RGroupScore.h.

Referenced by CartesianProduct(), and increment().

The documentation for this struct was generated from the following file:

- RGroupScore.h